#!/usr/bin/python3.6
#
# basic from chatterbot docs 
# extended by chrissie 08.2020
#

from chatterbot import ChatBot
from chatterbot.trainers import ListTrainer
import time
import random

# Uncomment the following lines to enable verbose logging
# import logging
# logging.basicConfig(level=logging.INFO)

# Create a new chat bot
buddha = ChatBot('Buddha',
    storage_adapter='chatterbot.storage.SQLStorageAdapter',
    database_uri='sqlite:///buddha.sqlite3'
    )
confucius = ChatBot('Confucius',
    storage_adapter='chatterbot.storage.SQLStorageAdapter',
    database_uri='sqlite:///conficius.sqlite3'
    )


# read buddha, confucius fortunes
b_lines = []
c_lines = []
with open('./101buddhafortune.txt') as f:
    for curline in f:
        if not curline.startswith("%"):
            b_lines.append(curline.rstrip())
with open('./75-confucius-fortunes.txt') as f:
    for curline in f:
        if not curline.startswith("%"):
            c_lines.append(curline.rstrip())

# do only training one time
# training will be saved somewhere
# user input will be added to training
training = 0
if training == 1:
    # reset database - beware!
    buddha.storage.drop()
    confucius.storage.drop()

    buddha_trainer = ListTrainer(buddha)
    buddha_trainer.train (b_lines)
    confucius_trainer = ListTrainer(confucius)
    confucius_trainer.train (c_lines)
    exit (1)

# get initial random confucius citication for buddha
c_count = len (c_lines)
c_rnd = random.randint(0, c_count)
c_rnd = c_rnd - 1

# get initial buddha response for the endless loop starting with confucius
buddha_response = buddha.get_response(c_lines[c_rnd])

# The following loop will execute each time the user enters input
while True:
    try:
        confucius_response = confucius.get_response(buddha_response)
        print("+ Confucius says: ", end='')
        print(confucius_response)
        time.sleep(1)
        buddha_response = buddha.get_response(confucius_response)
        print("! Buddha says: ", end='')
        print(buddha_response)
        time.sleep(1)

    # Press ctrl-c or ctrl-d on the keyboard to exit
    except (KeyboardInterrupt, EOFError, SystemExit):
        break
